# To run this example code
# git clone the historygraph library from https://github.com/mlockett42/historygraph
# Install it as per the instructions
# from inside the virtual env run the python interpreter
# Tested on Ubuntu 14.04 only

from historygraph import Document, DocumentObject, DocumentCollection, FieldList, FieldText

class Letter(DocumentObject):
    l = FieldText()

class Word(Document):
    w = FieldList(Letter)

    def print_word(self):
        return ''.join(l.l for l in self.w)

dc = DocumentCollection()
dc.Register(Letter)
dc.Register(Word)

a = Letter(None)

w1 = Word(None)

w1.w.insert(0, a)

a.l = 'a'

b = Letter(None)

w1.w.insert(1, b)

b.l = 'b'

w1.print_word()

w2 = w1.Clone()
dc.AddDocumentObject(w2)

w2.print_word()

w1.w.remove(1)

c = Letter(None)

w2.w.insert(2, c)

c.l = 'c'

w3 = w2.Merge(w1)




